﻿using Microsoft.Win32;
using Syncfusion.UI.Xaml.Diagram;
using Syncfusion.UI.Xaml.Diagram.Controls;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace NodePort
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();           
            diagram.Nodes = new ObservableCollection<NodeViewModel>();
            diagram.Connectors = new ObservableCollection<ConnectorViewModel>();
            NodeViewModel node1 = AddNode(100, 100, "Node1");
            NodeViewModel node2 = AddNode(500, 500, "Node2");
        }

        private NodeViewModel AddNode(double offx, double offy, string name)
        {
            NodeViewModel node = new NodeViewModel()
            {
                UnitWidth = 100,
                UnitHeight = 100,
                OffsetX = offx,
                OffsetY = offy,
            };
            node.Ports = new ObservableCollection<NodePortViewModel>();
            NodePortViewModel nodeport = new NodePortViewModel()
            {
               NodeOffsetX = 1,
               NodeOffsetY = .5,
               UnitWidth = 10,
               UnitHeight = 10
            };
            //cp1.PortDragMode = PortDragMode.Connect;
            nodeport.Constraints |= PortConstraints.OutConnect;
            nodeport.PortVisibility = PortVisibility.ValidConnection;
            nodeport.Constraints &= ~(PortConstraints.InheritPortVisibility);            
            (node.Ports as ObservableCollection<NodePortViewModel>).Add(nodeport);
            node.Annotations = new ObservableCollection<IAnnotation>()
            {
                new AnnotationEditorViewModel()
                {
                    Content=name
                }
            };
            (diagram.Nodes as ObservableCollection<NodeViewModel>).Add(node);
            return node;
        }

        private void save_Click(object sender, RoutedEventArgs e)
        {
            SaveFileDialog dialog = new SaveFileDialog();
            dialog.Title = "Save XAML";
            dialog.Filter = "XAML File (*.xaml)|*.xaml";
            if (dialog.ShowDialog() == true)
            {
                using (Stream s = File.Open(dialog.FileName, FileMode.CreateNew))
                {
                    diagram.Save(s);
                }
            }
        }

        private void load_Click(object sender, RoutedEventArgs e)
        {
            OpenFileDialog dialog = new OpenFileDialog();
            dialog.Filter = "XAML File (*.xaml)|*.xaml";
            if (dialog.ShowDialog() == true)
            {
                using (Stream myStream = dialog.OpenFile())
                {
                    diagram.Load(myStream);
                }
            }
        }
    }
}
